'''
Created on Mar 22, 2010

@author: john
'''
from fs import dirutils, file
from media import mp3
from tagger import puid,mbid
from utils import utils
import os, shutil, sys
import threading

def main(root,gulag,level,logfile,verbose,mode,update,player,filedb):
    if verbose: print "Scanning for files"
    #filedict is a dictionary (filed by extension) of lists of strings (file paths)
    filedict = dirutils.recursiveHopper(root,verbose)
    
    if verbose: print "Reading media files"
    #TODO refactoring for other media types will take place here
    # param filedb is a flat list of file objects (these will become updated) Note filedb is SORTED!
    #result is like filedb, but just for mp3s.
    scancount=[0]
    scan = Scan(sorted(filedict['.mp3']),filedb,scancount)
    scan.start()
    while scan.is_alive():
        scan.join(5.0)
        if verbose: print str(scancount[0])+' of '+str(len(filedict['.mp3']))+' files scanned'
    scan.join() # just to be sure
    if verbose: print "Getting PUIDs. Expect this to take a while (especially the first time), and expect to see errors while it's working."
    puidcount=[0,0]
    puids = puid.GetPuids(filedb,puidcount)
    puids.start()
    while puids.is_alive():
        puids.join(5.0)
        if verbose: print str(puidcount[0])+' of '+str(len(filedb))+' puids retrieved'
    if verbose: print 'Could not get puids for '+str(puidcount[1])+'files'
    puids.join() #just to be sure
    
    print ''
    
    if verbose: print "Beginning Level 1 analysis"
    #level1 is a dictionary keyed on puid
    level1 = sortL1(filedb)
    if (level>=1): exile(level1,gulag,verbose)
    
    if verbose: print "Getting MBIDs. Expect this to take a while."
    result2 = [l[0] for l in level1.values()]
    mbidcount = [0]
    termlock=threading.Lock()
    mbids = mbid.GetMbids(result2,mode,mbidcount, termlock, update, player)
    mbids.start()
    while mbids.is_alive():
        mbids.join(5.0)
        termlock.acquire()
        if verbose: print str(mbidcount[0])+' of '+str(len(result2))+' mbids retrieved'
        termlock.release()
    mbids.join()
    if verbose: print "Beginning Level 2 analysis"
    #level2 us a dictionary keyed on mbid
    level2 = sortL2(result2)
    if (level>=2): exile(level2,gulag,verbose)
    
    count1=0
    count2=0
    with open(os.path.join(root,logfile), 'w') as log:
        sep= '***************************************************************'
        for f in level1.keys():
            if len(level1[f]) > 1:
                if verbose > 1: print sep
                log.write(sep+'\n')
                if verbose > 1: print f
                log.write(str(f)+'\n')
                for i in level1[f]:
                    if verbose > 1: print i
                    log.write(str(i)+'\n')
                count1 += 1
        if verbose > 1: print 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
        log.write('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n')
        for f in level2.keys():
            if verbose > 1: print sep
            log.write(sep+'\n')
            if verbose > 1: print f
            log.write(str(f)+'\n')
            for i in level2[f]:
                if verbose > 1: print i
                log.write(str(i)+'\n')
            if len(level2[f])>1:
                count2 += 1
        if verbose: print str(count1)+' L1 duplicates found'
        if verbose: print str(count2)+' L2 duplicates found'
        if verbose: print str(len(level2))+' of '+str(len(filedb))+' files are unique'
        log.write(str(count1)+' L1 duplicates found\n')
        log.write(str(count2)+' L2 duplicates found\n')
        log.write(str(len(level2))+' of '+str(len(filedict['.mp3']))+' files are unique\n')
    return filedb

class Scan(threading.Thread):
    def __init__(self,flist,fdb,count):
        threading.Thread.__init__(self)
        self.flist = flist
        self.fdb = fdb
        self.count = count 
    
    def run(self):
        # O(n^2)=bad, but acceptable for now because the cost for looking up IDs is so high.
        i=0
        for s in self.flist:
            while i<len(self.fdb) and s > self.fdb[i].getPath():
                i+=1
            if i==len(self.fdb) or not file.pathIsFile(s, self.fdb[i]):
                self.fdb.insert(i,mp3.newmp3(s))
            self.count[0] += 1
        
def sortL1(fdb):
    res = dict()
    for f in fdb:
        if f.puid in res: utils.insort(res[f.puid],f)
        else: res[f.puid] = [f]
    return res

def sortL2(fdb):  
    res = dict()
    for f in fdb:
        if f.mbid in res: utils.insort(res[f.mbid],f)
        else: res[f.mbid] = [f]
    return res

def exile(fdict,gulag,verbose):
    if verbose: print "Exiling duplicates"
    for key in fdict.keys():
        if not (key == None or key == 'None' or key == ''):
            move(fdict[key][1:],gulag)

def move(files,path):
    if not os.path.exists(path):
        os.mkdir(path)
    for f in files:
        origFile = os.path.split(f.getPath())[1]
        if (os.path.exists(os.path.join(path, origFile))):
            destFileName = origFile[:-4] + '_dcopy.mp3'
        else: destFileName = origFile
        shutil.move(f.getPath(), os.path.join(path,destFileName))
        f.setPath(os.path.join(path,destFileName))