'''
Created on Mar 22, 2010

@author: john
'''

import threading, time, random
import musicbrainz2.webservice as ws #@UnresolvedImport
import fs.file as myfile

def getmbid(puid):
    q=ws.Query()
    if puid:
        results = q.getTracks(ws.TrackFilter(puid=puid))
        if len(results)>1:
            result = userResolve(file, results)
        elif len(results)<1:
            result = None
        else: result = results[0]
        if result: mbid = result.getTrack().getId()
    return mbid

def getmbids(files,count,mode,termlock,update, player):
    q=ws.Query()
    tic=0
    for file in files:
        #print file.mbid
        if (file.mbid==None) and file.puid and file.verifyExists():
            #print file.mbid
            query = False
            timeout = 10
            while timeout and not query:
                try:
                    results = q.getTracks(ws.TrackFilter(puid=file.puid))
                    query = True
                except:
                    time.sleep(1+random.random()*5)
                    timeout -=1
                    
            if len(results)>1:
                tic +=1
                if mode == 'AUTO' or mode =='SEMI':
                    resultInd = semiResolve(file,results,termlock,mode,player)
                else:
                    resultInd = userResolve(file, results,termlock,player)
                if not resultInd == None:
                    result = results[resultInd]
                else:
                    result = None
                    file.mbid=None
            elif len(results)<1:
                result = None
                file.mbid = None
            else:
                result = results[0]
            if not result == None: 
                file.mbid = result.getTrack().getId()
                if update=='ALL' or (update=='SOME' and file.toupdate ) or (update=='ALL_ASK' and updateChallenge(file,result.getTrack(), termlock)) or (update=='SOME_ASK' and file.toupdate and updateChallenge(file,result.getTrack(),termlock)):
                    updatetag(file,result.getTrack())
                    file.toupdate=False
        count[0] += 1
        
def updatetag(elem,track):
    elem.setArtist(track.getArtist().getName())
    elem.setTitle(track.getTitle())
    release = track.getReleases()[0]
    elem.setAlbum(release.getTitle())
    if release.getTracks():
        elem.track[0] = release.getTracksOffset() + release.getTracks().index(track)
    elem.updatefile()
    
    

def updateChallenge(file,track,termlock):
    termlock.acquire()
    cont = True
    while cont:
        print file.artistFull+' < '+track.getArtist().getName()
        print file.titleFull+' < '+track.getTitle()
        release = track.getReleases()[0]
        print file.albumFull+' < '+release.getTitle()
        if release.getTracks(): print file.track[0]+' < '+release.getTracksOffset() + release.getTracks().index(track)
        resp = raw_input('Update file info from Internet? [Y,n]').lower()
        if resp=='n':
            result = False
            cont = False
        elif resp=='y' or resp=='':
            result = True
            cont = False
        else: print 'Enter "y" or "n"'
    termlock.release()
    return result

def userResolve(file, results,termlock,player):
    termlock.acquire()
    print '*************************************************************'+'\n'
    print 'This file\'s PUID is associated with more than one MusicBrainz Id. Please enter the number of the correct match:'
    print 'Your file:'
    print file
    print '\nMBID results:'
    for i in range(0,len(results)):
        print str(i)+': ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^'
        print '\tTitle:\t'+results[i].getTrack().getTitle()
        print '\tArtist:\t'+results[i].getTrack().getArtist().getName()
        print '\tReleases:\t',
        for r in results[i].getTrack().getReleases(): print r.getTitle()+'\t',
        print ''
        print '\tDuration:\t'+str(results[i].getTrack().getDuration())
        print '\n'
    while True:
        try:
            ans = raw_input("Enter the number of the correct match, \"p\" to play the file, or \"n\" if none of the matches are correct: ")
            if ans == "p":
                import os
                temp = file.getPath()
                playstring = player % file.getPath()
                os.system(str(playstring))
            elif ans == "n":
                termlock.release()
                return None
            else:
                intans = int(ans)
                termlock.release()
                file.toupdate=True
                return intans
        except ValueError:
            print "Could not parse your input; enter an integer."

def semiResolve(file, results,termlock,mode,player):
    candidates1 = [x for x in results if myfile.clean(x.getTrack().getArtist().getName()) == file.artist]
    candidates2 = [x for x in candidates1 if myfile.clean(x.getTrack().getTitle()) == file.title]
    candidates3 = [x for x in candidates2 if file.album in [myfile.clean(y.getTitle()) for y in x.getTrack().getReleases()]]
    cdss = [candidates1,candidates2,candidates3]
    tmpBest = -1
    index=3
    while tmpBest == -1 and index >= 0:
        index -= 1
        tmpBest = autoResolve(file,cdss[index],termlock)
    if tmpBest == -1:
        if mode=='AUTO':
            return autoResolve(file,results,termlock)
        else:
            return userResolve(file,results,termlock,player)
    else:
        return results.index(cdss[index][tmpBest])

def autoResolve(file, results,termlock):
    # For now, just use the one whose duration is the closest.
    closest = 0
    i=-1
    for i in range(0,len(results)):
        if file.duration:
            if not results[closest].getTrack().getDuration():
                closest = i
            elif results[i].getTrack().getDuration():
                if abs(int(results[i].getTrack().getDuration())-file.duration) < abs(int(results[closest].getTrack().getDuration())-file.duration):
                    closest = i
        else:
            print "Auto mode failure: duration missing..."
            i=userResolve(file,results,termlock)
    return i
    
    #candidates = results[:]
    

class GetMbids(threading.Thread):
    def __init__(self, files,mode,count,termlock, update, player):
        threading.Thread.__init__(self)
        self.files = files
        self.mode = mode
        self.count = count
        self.termlock = termlock
        self.update = update
        self.player = player
        
    def run(self):
        getmbids(self.files, self.count, self.mode, self.termlock, self.update, self.player)

#print getmbid('e48488a1-5bfa-29f9-c1a5-bf38ef925c23')
